<?php
/*
  $Id$

  Modular Checkout by @raiwa
  info@oscaddons.com
  www.oscaddons.com
  
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2018 osCommerce

  Released under the GNU General Public License
*/

  class cm_cc_summary {
    var $code;
    var $group;
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->code = get_class($this);
      $this->group = basename(dirname(__FILE__));

      $this->title = MODULE_CONTENT_CHECKOUT_CONFIRMATION_SUMMARY_TITLE;
      $this->description = MODULE_CONTENT_CHECKOUT_CONFIRMATION_SUMMARY_DESCRIPTION;
      $this->description .= '<div class="secWarning">' . MODULE_CONTENT_BOOTSTRAP_ROW_DESCRIPTION . '</div>';

      if ( defined('MODULE_CONTENT_CHECKOUT_CONFIRMATION_SUMMARY_STATUS') ) {
        $this->sort_order = MODULE_CONTENT_CHECKOUT_CONFIRMATION_SUMMARY_SORT_ORDER;
        $this->enabled = (MODULE_CONTENT_CHECKOUT_CONFIRMATION_SUMMARY_STATUS == 'True');
      }
    }

    function execute() {
      global $oscTemplate, $order, $sendto, $payment_modules, $payment, $$payment, $shipping_modules, $shipping;

      $content_width = (int)MODULE_CONTENT_CHECKOUT_CONFIRMATION_SUMMARY_CONTENT_WIDTH;

  $payment_modules->update_status();

  if ( ($payment_modules->selected_module != $payment) || ( is_array($payment_modules->modules) && (sizeof($payment_modules->modules) > 1) && !is_object($$payment) ) || (is_object($$payment) && ($$payment->enabled == false)) ) {
    tep_redirect(tep_href_link('checkout_payment.php', 'error_message=' . urlencode(ERROR_NO_PAYMENT_MODULE_SELECTED), 'SSL'));
  }

  if (is_array($payment_modules->modules)) {
    $payment_modules->pre_confirmation_check();
  }

        ob_start();
        include('includes/modules/content/' . $this->group . '/templates/tpl_' . basename(__FILE__));
        $template = ob_get_clean();

        $oscTemplate->addContent($template, $this->group);
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_CONTENT_CHECKOUT_CONFIRMATION_SUMMARY_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Summary Module', 'MODULE_CONTENT_CHECKOUT_CONFIRMATION_SUMMARY_STATUS', 'True', 'Should this module be shown on the checkout confirmation page?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Width', 'MODULE_CONTENT_CHECKOUT_CONFIRMATION_SUMMARY_CONTENT_WIDTH', '12', 'What width container should the content be shown in?', '6', '1', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_CONTENT_CHECKOUT_CONFIRMATION_SUMMARY_SORT_ORDER', '300', 'Sort order of display. Lowest is displayed first.', '6', '1', now())");
    }

    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_CONTENT_CHECKOUT_CONFIRMATION_SUMMARY_STATUS', 'MODULE_CONTENT_CHECKOUT_CONFIRMATION_SUMMARY_CONTENT_WIDTH', 'MODULE_CONTENT_CHECKOUT_CONFIRMATION_SUMMARY_SORT_ORDER');
    }
  }
